## adios2-master.zip

=== CMakeLists.txt ===
#------------------------------------------------------------------------------#
# Distributed under the OSI-approved Apache License, Version 2.0.  See
# accompanying file Copyright.txt for details.
#------------------------------------------------------------------------------#

cmake_minimum_required(VERSION 3.12)

# Fail immediately if not using an out-of-source build
if(CMAKE_CURRENT_SOURCE_DIR STREQUAL CMAKE_CURRENT_BINARY_DIR)
  message(FATAL_ERROR
    "In-source builds are not supported.  Please create a build directory "
    "separate from the source directory")
endif()

include(${CMAKE_CURRENT_LIST_DIR}/cmake/ADIOSFunctions.cmake)

setup_version(2.5.0)

project(ADIOS2 VERSION ${ADIOS2_VERSION})

#------------------------------------------------------------------------------#
# Some boilerplate to setup nice output directories
#------------------------------------------------------------------------------#
include(GNUInstallDirs)
set(CMAKE_INSTALL_CMAKEDIR ${CMAKE_INSTALL_LIBDIR}/cmake/adios2
  CACHE STRING "Installation CMake subdirectory")
mark_as_advanced(CMAKE_INSTALL_CMAKEDIR)

list(INSERT CMAKE_MODULE_PATH 0 "${PROJECT_SOURCE_DIR}/cmake")
if(NOT CMAKE_ARCHIVE_OUTPUT_DIRECTORY)
  set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY
    ${PROJECT_BINARY_DIR}/${CMAKE_INSTALL_LIBDIR})
endif()
if(NOT CMAKE_LIBRARY_OUTPUT_DIRECTORY)
  set(CMAKE_LIBRARY_OUTPUT_DIRECTORY
    ${PROJECT_BINARY_DIR}/${CMAKE_INSTALL_LIBDIR})
endif()
if(NOT CMAKE_RUNTIME_OUTPUT_DIRECTORY)
  set(CMAKE_RUNTIME_OUTPUT_DIRECTORY
    ${PROJECT_BINARY_DIR}/${CMAKE_INSTALL_BINDIR})
endif()

# Let windows builds auto-export dll symbols
set(CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS TRUE)

#------------------------------------------------------------------------------#
# Silence MSVC warnings
#------------------------------------------------------------------------------#

if(MSVC)
  add_definitions(
    -D_CRT_SECURE_NO_DEPRECATE
    -D_CRT_SECURE_NO_WARNINGS
    -D_SCL_SECURE_NO_DEPRECATE
    -D_SILENCE_TR1_NAMESPACE_DEPRECATION_WARNING
  )
endif()

#------------------------------------------------------------------------------#
# Deal with any pre-installation cleanup tasks
#------------------------------------------------------------------------------#
add_subdirectory(cmake/install/pre)

#------------------------------------------------------------------------------#
# Top level options
#------------------------------------------------------------------------------#

# Default to a debug build if not specified
if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
  set(CMAKE_BUILD_TYPE "Release" CACHE STRING "Choose the type of build." FORCE)
endif()

# Force C++11 and C99
set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED True)
if(NOT MSVC)
  set(CMAKE_C_STANDARD 99)
  set(CMAKE_C_STANDARD_REQUIRED True)
endif()

# Option for packagers to add a suffix after "adios" in library names (to
# install multiple builds in parallel)
set(ADIOS2_LIBRARY_SUFFIX "" CACHE STRING
  "Suffix to put after \"adios\" in library names")
set(ADIOS2_EXECUTABLE_SUFFIX "${ADIOS2_LIBRARY_SUFFIX}" CACHE STRING
  "Suffix to append to executable names")
mark_as_advanced(ADIOS2_LIBRARY_SUFFIX ADIOS2_EXECUTABLE_SUFFIX)

# Use meta-compile features if available, otherwise use specific language
# features
if(CMAKE_VERSION VERSION_LESS 3.9 OR
   CMAKE_CXX_COMPILER_ID MATCHES "^(GNU|Intel|Clang|AppleClang|MSVC)$")
  set(ADIOS2_CXX11_FEATURES cxx_auto_type cxx_nullptr)
else()
  set(ADIOS2_CXX11_FEATURES cxx_std_11)
endif()
if(CMAKE_VERSION VERSION_LESS 3.9 OR
   CMAKE_C_COMPILER_ID MATCHES "^(GNU|Intel|Clang|AppleClang|MSVC)$")
  set(ADIOS2_C99_FEATURES c_restrict)
else()
  set(ADIOS2_C99_FEATURES c_std_99)
endif()

include(CMakeDependentOption)

# Setup shared library defaults.  If explicitly specified somehow, then default
# to that.  Otherwise base the default on whether or not shared libs are even
# supported.
get_property(SHARED_LIBS_SUPPORTED GLOBAL PROPERTY TARGET_SUPPORTS_SHARED_LIBS)
cmake_dependent_option(BUILD_SHARED_LIBS
  "Build shared libraries (so/dylib/dll)." ${SHARED_LIBS_SUPPORTED}
  "SHARED_LIBS_SUPPORTED" OFF
)
mark_as_advanced(BUILD_SHARED_LIBS)
if((NOT BUILD_SHARED_LIBS) AND (NOT DEFINED CMAKE_POSITION_INDEPENDENT_CODE))
  set(CMAKE_POSITION_INDEPENDENT_CODE ON)
endif()

adios_option(Blosc     "Enable support for Blosc transforms" AUTO)
adios_option(BZip2     "Enable support for BZip2 transforms" AUTO)
adios_option(ZFP       "Enable support for ZFP transforms" AUTO)
adios_option(SZ        "Enable support for SZ transforms" AUTO)
adios_option(MGARD     "Enable support for MGARD transforms" AUTO)
adios_option(PNG       "Enable support for PNG transforms" AUTO)
adios_option(MPI       "Enable support for MPI" AUTO)
adios_option(DataMan   "Enable support for DataMan" AUTO)
adios_option(DataSpaces "Enable support for DATASPACES" AUTO)
adios_option(SSC       "Enable support for SSC" AUTO)
adios_option(Table     "Enable support for Table" AUTO)
adios_option(SST       "Enable support for SST" AUTO)
adios_option(ZeroMQ    "Enable support for ZeroMQ" AUTO)
adios_option(HDF5      "Enable support for the HDF5 engine" AUTO)
adios_option(Python    "Enable support for Python bindings" AUTO)
adios_option(Fortran   "Enable support for Fortran bindings" AUTO)
adios_option(SysVShMem "Enable support for SysV Shared Memory IPC on *NIX" AUTO)
adios_option(Profiling "Enable support for profiling" AUTO)
adios_option(Endian_Reverse "Enable support for Little/Big Endian Interoperability" AUTO)
include(${PROJECT_SOURCE_DIR}/cmake/DetectOptions.cmake)

if(ADIOS2_HAVE_MPI)
  if(MPIEXEC_MAX_NUMPROCS LESS 4 AND "$ENV{OMPI_MCA_rmaps_base_oversubscribe}")
    message(STATUS "OpenMPI oversubscribe detected: raising MPIEXEC_MAX_NUMPROCS to 4 for testing")
    set(MPIEXEC_MAX_NUMPROCS 4 CACHE STRING "" FORCE)
  endif()

  # Workaround for MPI forcing the link of C++ bindings
  add_definitions(-DOMPI_SKIP_MPICXX -DMPICH_SKIP_MPICXX)
endif()

set(ADIOS2_CONFIG_OPTS
    Blosc BZip2 ZFP SZ MGARD PNG MPI DataMan Table SSC SST DataSpaces ZeroMQ HDF5 Python Fortran SysVShMem Profiling Endian_Reverse
)
GenerateADIOSHeaderConfig(${ADIOS2_CONFIG_OPTS})
configure_file(
  ${PROJECT_SOURCE_DIR}/CTestCustom.cmake.in
  ${PROJECT_BINARY_DIR}/CTestCustom.cmake
  @ONLY
)

install(FILES ${PROJECT_BINARY_DIR}/source/adios2/common/ADIOSConfig.h
  DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/adios2/common
  COMPONENT adios2_core-development
)

#------------------------------------------------------------------------------#
# Some specialized shared library and RPATH handling
#------------------------------------------------------------------------------#
option(ADIOS2_RUN_INSTALL_TEST "Enable / disable the install test" TRUE)
mark_as_advanced(ADIOS2_RUN_INSTALL_TEST)
if(BUILD_SHARED_LIBS AND ADIOS2_RUN_INSTALL_TEST)
  set(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
  string(REGEX REPLACE "[^/]+" ".." relative_base "${CMAKE_INSTALL_LIBDIR}")

  if(APPLE)
    # Various homebrew MPI fortran installations break rpath usage on OSX
    if(APPLE AND ADIOS2_HAVE_Fortran AND ADIOS2_HAVE_MPI)
      set(CMAKE_MACOSX_RPATH OFF)
      if(NOT CMAKE_VERSION VERSION_LESS 3.17)
        set(CMAKE_INSTALL_NAME_DIR
          "$<INSTALL_PREFIX>/${CMAKE_INSTALL_LIBDIR}")
      else()
        set(CMAKE_INSTALL_NAME_DIR
          "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}")
        message(STATUS "Skipping install tests due to platform specific rpath oddities")
        set(ADIOS2_RUN_INSTALL_TEST FALSE)
      endif()
    else()
      set(CMAKE_INSTALL_RPATH "@loader_path/${relative_base}/${CMAKE_INSTALL_LIBDIR}")
    endif()

  elseif(CMAKE_SYSTEM_NAME MATCHES "Linux")
    # Linux needs some specialized RPATH handling
    set(CMAKE_INSTALL_RPATH "$ORIGIN/${relative_base}/${CMAKE_INSTALL_LIBDIR}")
  endif()
endif()

#------------------------------------------------------------------------------#
# Third party libraries
#------------------------------------------------------------------------------#
include(CTest)
mark_as_advanced(BUILD_TESTING)
add_subdirectory(thirdparty)

#------------------------------------------------------------------------------#
# Main library source
#------------------------------------------------------------------------------#
add_subdirectory(source)

#------------------------------------------------------------------------------#
# Language bindings
#------------------------------------------------------------------------------#
add_subdirectory(bindings)

#------------------------------------------------------------------------------#
# Examples
#------------------------------------------------------------------------------#
option(ADIOS2_BUILD_EXAMPLES "Build examples" ON)
option(ADIOS2_BUILD_EXAMPLES_EXPERIMENTAL "Build experimental examples" OFF)
if(ADIOS2_BUILD_EXAMPLES)
  add_subdirectory(examples)
endif()

#------------------------------------------------------------------------------#
# Testing
#------------------------------------------------------------------------------#
if(DEFINED BUILD_TESTING)
  set(ADIOS2_BUILD_TESTING_DEFAULT ${BUILD_TESTING})
else()
  set(ADIOS2_BUILD_TESTING_DEFAULT ON)
endif()
unset(BUILD_TESTING)
option(ADIOS2_BUILD_TESTING "Build the ADIOS2 testing tree" 
  ${ADIOS2_BUILD_TESTING_DEFAULT})

cmake_dependent_option(ADIOS2_RUN_MPI_MPMD_TESTS
  "Enable the parallel MPMD tests" ON
  "ADIOS2_BUILD_TESTING;ADIOS2_HAVE_MPI" OFF)
mark_as_advanced(ADIOS2_RUN_MPMD_TESTS)

include(CTest)
set(BUILD_TESTING ${ADIOS2_BUILD_TESTING})
if(BUILD_TESTING)
  find_program(DIFF_EXECUTABLE diff)
  if(DIFF_EXECUTABLE)
    set(DIFF_COMMAND ${DIFF_EXECUTABLE})
  elseif(GIT_COMMAND)
    set(DIFF_COMMAND ${GIT_COMMAND} diff)
  elseif(GITCOMMAND)
    set(DIFF_COMMAND ${GITCOMMAND} diff)
  endif()
  if(NOT DIFF_COMMAND)
    message(FATAL_ERROR "diff command is required for testing")
  endif()

  enable_testing()
  add_subdirectory(testing)
endif()

#------------------------------------------------------------------------------#
# Generating package configs
#------------------------------------------------------------------------------#
add_subdirectory(cmake/install/packaging)

#------------------------------------------------------------------------------#
# Generating static adios-config
#------------------------------------------------------------------------------#
option(ADIOS2_INSTALL_GENERATE_CONFIG "Install a generated adios2-config shell script for non-cmake projects" ON)
mark_as_advanced(ADIOS2_INSTALL_GENERATE_CONFIG)
if(ADIOS2_INSTALL_GENERATE_CONFIG)
  add_subdirectory(cmake/install/post)
endif()

#------------------------------------------------------------------------------#
# Configuration summary
#------------------------------------------------------------------------------#
message("")
message("ADIOS2 build configuration:")
message("  ADIOS Version: ${ADIOS2_VERSION}")
message("  C++ Compiler : ${CMAKE_CXX_COMPILER_ID} " 
                         "${CMAKE_CXX_COMPILER_VERSION} " 
                         "${CMAKE_CXX_COMPILER_WRAPPER}")
message("    ${CMAKE_CXX_COMPILER}")
message("")
if(ADIOS2_HAVE_Fortran)
  message("  Fortran Compiler : ${CMAKE_Fortran_COMPILER_ID} "
                               "${CMAKE_Fortran_COMPILER_VERSION} "
                               "${CMAKE_Fortran_COMPILER_WRAPPER}")
  message("    ${CMAKE_Fortran_COMPILER}")
  message("")
endif()
message("  Installation prefix: ${CMAKE_INSTALL_PREFIX}")
message("        bin: ${CMAKE_INSTALL_BINDIR}")
message("        lib: ${CMAKE_INSTALL_LIBDIR}")
message("    include: ${CMAKE_INSTALL_INCLUDEDIR}")
message("      cmake: ${CMAKE_INSTALL_CMAKEDIR}")
if(DEFINED CMAKE_INSTALL_PYTHONDIR)
  message("     python: ${CMAKE_INSTALL_PYTHONDIR}")
endif()
message("")
message("  Features:")
if(BUILD_SHARED_LIBS)
  set(msg_lib_type "shared")
elseif(CMAKE_POSITION_INDEPENDENT_CODE)
  set(msg_lib_type "static (with PIC)")
else()
  set(msg_lib_type "static (without PIC)")
endif()

=== testing/CMakeLists.txt ===
#------------------------------------------------------------------------------#
# Distributed under the OSI-approved Apache License, Version 2.0.  See
# accompanying file Copyright.txt for details.
#------------------------------------------------------------------------------#

if(ADIOS2_HAVE_MPI)
  set(MPIEXEC_EXTRA_FLAGS "" CACHE STRING
      "Extra flags to set after mpiexec and before the num_procs flag"
  )
  mark_as_advanced(MPIEXEC_EXTRA_FLAGS)
  separate_arguments(MPIEXEC_EXTRA_FLAGS)

  set(MPIEXEC_COMMAND
    ${MPIEXEC_EXECUTABLE} ${MPIEXEC_EXTRA_FLAGS}
    ${MPIEXEC_NUMPROC_FLAG} ${MPIEXEC_MAX_NUMPROCS}
  )
endif()

include(GoogleTest)
# gtest_add_tests_helper:
# Create a wrapper around gtest_add_tests that uses common patterns for test
# names, execurtable names, mpi usage, etc.
#
# Arguments:
#   testname - The basename of the test file
#   mpi      - MPI_ALLOW - build MPI test, execute with mpiexec; also build Serial test
#              MPI_NONE - build Serial test only
#              MPI_ONLY - build MPI test only, execute with mpiexec
#              MPI_NOEXEC - build MPI test, execute without MPI; also build Serial test
#   src_pfx  - Source filename prefix, Test${src_pfs}${testname}.cpp
#   tst_pfx  - Test name prefix to be added to CTest
#   tst_sfx  - Test name suffix to be added to CTest
# all additional arguments are passed directly to gtest_add_tests
#
# Example:
#   You have a gtest file, TestFooThings.cpp that containst Test1 and Test2
#   gtest functions that can be called with different sets of arguments.
#
#     gtest_add_tests_helper(Things MPI_ALLOW Foo Foo. .Bar EXTRA_ARGS "Bar")
#     gtest_add_tests_helper(Things MPI_ALLOW Foo Foo. .Baz EXTRA_ARGS "Baz")
#
#  will create the executable Test.Foo.Things and add the tests
#    Foo.Things.Test1.Bar.Serial
#    Foo.Things.Test1.Bar.MPI
#    Foo.Things.Test2.Bar.Serial
#    Foo.Things.Test2.Bar.MPI
#    Foo.Things.Test1.Baz.Serial
#    Foo.Things.Test1.Baz.MPI
#    Foo.Things.Test2.Baz.Serial
#    Foo.Things.Test2.Baz.MPI
#
function(gtest_add_tests_helper testname mpi src_pfx tst_pfx tst_sfx)
  set(test_targets "")
  if(NOT mpi MATCHES "^MPI_(ALLOW|NONE|ONLY|NOEXEC)$")
    message(FATAL_ERROR "Invalid mpi argument value '${mpi}'.")
  endif()
  if(NOT mpi STREQUAL "MPI_ONLY")
    set(tgt Test.${tst_pfx}${testname}.Serial)
    list(APPEND test_targets "${tgt}")
    if(NOT TARGET ${tgt})
      add_executable(${tgt} Test${src_pfx}${testname}.cpp)
      target_link_libraries(${tgt} adios2::cxx11 adios2::c adios2_core adios2::thirdparty::gtest)
    endif()
    gtest_add_tests(TARGET ${tgt}
      TEST_PREFIX "${tst_pfx}"
      TEST_SUFFIX "${tst_sfx}.Serial"
      ${ARGN}
    )
  endif()
  if(ADIOS2_HAVE_MPI AND NOT mpi STREQUAL "MPI_NONE")
    set(tgt Test.${tst_pfx}${testname}.MPI)
    list(APPEND test_targets "${tgt}")
    if(NOT TARGET ${tgt})
      add_executable(${tgt} Test${src_pfx}${testname}.cpp)
      target_link_libraries(${tgt} adios2::cxx11_mpi adios2::c_mpi adios2_core_mpi MPI::MPI_C adios2::thirdparty::gtest)
    endif()
    if(NOT mpi STREQUAL "MPI_NOEXEC")
      gtest_add_tests(TARGET ${tgt}
        TEST_PREFIX "${tst_pfx}"
        TEST_SUFFIX "${tst_sfx}.MPI"
        EXEC_WRAPPER ${MPIEXEC_COMMAND}
        TEST_LIST added_tests
        ${ARGN}
        )
      set_tests_properties(${added_tests} PROPERTIES PROCESSORS "${MPIEXEC_MAX_NUMPROCS}")
    else()
      gtest_add_tests(TARGET ${tgt}
        TEST_PREFIX "${tst_pfx}"
        TEST_SUFFIX "${tst_sfx}.MPI"
        ${ARGN}
        )
    endif()
  endif()
  set("Test.${tst_pfx}${testname}-TARGETS" "${test_targets}" PARENT_SCOPE)
endfunction()

add_subdirectory(adios2)
add_subdirectory(utils)
if(ADIOS2_RUN_INSTALL_TEST)
  add_subdirectory(install)
endif()

if(ADIOS2_BUILD_EXAMPLES)
  add_subdirectory(examples)
endif()

=== thirdparty/CMakeLists.txt ===
# Disable warnings in thirdparty code
if(CMAKE_C_COMPILER_ID MATCHES
    "^(GNU|Clang|AppleClang|XLClang|XL|VisualAge|SunPro|HP|Intel)$")
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -w")
endif()
if(CMAKE_CXX_COMPILER_ID MATCHES
    "^(GNU|Clang|AppleClang|XLClang|XL|VisualAge|SunPro|HP|Intel)$")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -w")
endif()


function(message_start_thirdparty)
  get_filename_component(tp_base "${CMAKE_CURRENT_LIST_DIR}" NAME_WE)
  message("")
  message(STATUS "ADIOS2 ThirdParty: Configuring ${tp_base}")
endfunction()

function(message_end_thirdparty)
endfunction()

include(CMakeDependentOption)

option(ADIOS2_USE_EXTERNAL_DEPENDENCIES
  "Use externally supplied dependencies" OFF)
option(ADIOS2_USE_EXTERNAL_GTEST
  "Use an externally supplied GTest library" "${ADIOS2_USE_EXTERNAL_DEPENDENCIES}")
option(ADIOS2_USE_EXTERNAL_PUGIXML
  "Use an externally supplied pugixml library" "${ADIOS2_USE_EXTERNAL_DEPENDENCIES}")
option(ADIOS2_USE_EXTERNAL_PYBIND11
  "Use an externally supplied pybind11 library" "${ADIOS2_USE_EXTERNAL_DEPENDENCIES}")
option(ADIOS2_USE_EXTERNAL_NLOHMANN_JSON
  "Use an externally supplied nlohmann_json library" "${ADIOS2_USE_EXTERNAL_DEPENDENCIES}")
option(ADIOS2_USE_EXTERNAL_YAMLCPP
  "Use an externally supplied yaml-cpp library" "${ADIOS2_USE_EXTERNAL_DEPENDENCIES}")

add_subdirectory(KWSys)

if(BUILD_TESTING)
  if(ADIOS2_USE_EXTERNAL_GTEST)
    find_package(GTest REQUIRED)
    adios2_add_thirdparty_target(gtest GTest::GTest)
  else()
    add_subdirectory(GTest)
    adios2_add_thirdparty_target(gtest gtest_interface)
  endif()
endif()

if(ADIOS2_HAVE_Python)
  if(ADIOS2_USE_EXTERNAL_PYBIND11)
    find_package(pybind11 REQUIRED)
    adios2_add_thirdparty_target(pybind11 pybind11::pybind11)
  else()
    add_subdirectory(pybind11)
    adios2_add_thirdparty_target(pybind11 pybind11)
  endif()
endif()

if(ADIOS2_USE_EXTERNAL_PUGIXML)
  find_package(pugixml 1.10 REQUIRED)
  add_library(pugixml_impl INTERFACE)
  target_link_libraries(pugixml_impl INTERFACE pugixml)
else()
  add_subdirectory(pugixml)
endif()
adios2_add_thirdparty_target(pugixml pugixml)
adios2_add_thirdparty_target(pugixml_impl pugixml_impl)
if(ADIOS2_USE_EXTERNAL_NLOHMANN_JSON)
  find_package(nlohmann_json REQUIRED)
  adios2_add_thirdparty_target(nlohmann_json nlohmann_json::nlohmann_json)
else()
  add_subdirectory(nlohmann_json)
  adios2_add_thirdparty_target(nlohmann_json nlohmann_json)
endif()
if(ADIOS2_USE_EXTERNAL_YAMLCPP)
  find_package(yaml-cpp REQUIRED)
else()
  add_subdirectory(yaml-cpp)
endif()
adios2_add_thirdparty_target(yaml-cpp yaml-cpp)

if(WIN32)
  add_subdirectory(mingw-w64)
endif()

#------------------------------------------------------------------------------#
# SST / EVPath stuff
#------------------------------------------------------------------------------#
cmake_dependent_option(ADIOS2_USE_EXTERNAL_EVPATH
  "Use an externally supplied EVPath library" OFF
  "ADIOS2_HAVE_SST" OFF
)
cmake_dependent_option(ADIOS2_USE_EXTERNAL_ATL
  "Use an externally supplied ATL library" OFF
  "NOT ADIOS2_USE_EXTERNAL_EVPATH" OFF
)
cmake_dependent_option(ADIOS2_USE_EXTERNAL_FFS
  "Use an externally supplied FFS library" OFF
  "NOT ADIOS2_USE_EXTERNAL_EVPATH" OFF
)
cmake_dependent_option(ADIOS2_USE_EXTERNAL_DILL
  "Use an externally supplied DILL library" OFF
  "NOT ADIOS2_USE_EXTERNAL_FFS" OFF
)
cmake_dependent_option(ADIOS2_USE_EXTERNAL_ENET
  "Use an externally supplied ENET library" OFF
  "NOT ADIOS2_USE_EXTERNAL_EVPATH" OFF
)

if(ADIOS2_HAVE_SST)
  if(NOT ADIOS2_USE_EXTERNAL_EVPATH)
    if(NOT ADIOS2_USE_EXTERNAL_ATL)
      add_subdirectory(atl)
    endif()
    find_package(atl REQUIRED)

    if(NOT ADIOS2_USE_EXTERNAL_FFS)
      if(NOT ADIOS2_USE_EXTERNAL_DILL)
        add_subdirectory(dill)
      endif()
      find_package(dill REQUIRED)

      add_subdirectory(ffs)
    endif()
    find_package(ffs REQUIRED)

    if(NOT ADIOS2_USE_EXTERNAL_ENET)
      add_subdirectory(enet)
    endif()
    find_package(enet REQUIRED)

    add_subdirectory(EVPath)
  endif()
  find_package(EVPath REQUIRED)
  adios2_add_thirdparty_target(EVPath EVPath::EVPath)
endif()

# Keep this at the end so we see the verbose messages at least once
set(ADIOS2_THIRDPARTY_VERBOSE_DISABLE TRUE CACHE INTERNAL "" FORCE)
message("")

=== bindings/CXX11/CMakeLists.txt ===
#------------------------------------------------------------------------------#
# Distributed under the OSI-approved Apache License, Version 2.0.  See
# accompanying file Copyright.txt for details.
#------------------------------------------------------------------------------#

add_library(adios2_cxx11
  adios2/cxx11/ADIOS.cpp
  adios2/cxx11/Attribute.cpp
  adios2/cxx11/Engine.cpp
  adios2/cxx11/Engine.tcc
  adios2/cxx11/IO.cpp
  adios2/cxx11/IO.tcc
  adios2/cxx11/Operator.cpp
  adios2/cxx11/Query.cpp
  adios2/cxx11/Types.cpp
  adios2/cxx11/Types.tcc
  adios2/cxx11/Variable.cpp
  adios2/cxx11/fstream/ADIOS2fstream.cpp
)
set_property(TARGET adios2_cxx11 PROPERTY EXPORT_NAME cxx11)
set_property(TARGET adios2_cxx11 PROPERTY OUTPUT_NAME adios2${ADIOS2_LIBRARY_SUFFIX}_cxx11)
target_link_libraries(adios2_cxx11 PRIVATE adios2_core adios2::thirdparty::pugixml)
target_compile_features(adios2_cxx11 INTERFACE ${ADIOS2_CXX11_FEATURES})

target_include_directories(adios2_cxx11
  PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
    $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
  INTERFACE
    $<BUILD_INTERFACE:$<TARGET_PROPERTY:adios2_core,INTERFACE_INCLUDE_DIRECTORIES>>
)

add_library(adios2::cxx11 ALIAS adios2_cxx11)

if(ADIOS2_HAVE_MPI)
  add_library(adios2_cxx11_mpi
    adios2/cxx11/ADIOSMPI.cpp
    adios2/cxx11/IOMPI.cpp
    adios2/cxx11/fstream/ADIOS2fstreamMPI.cpp
  )
  set_property(TARGET adios2_cxx11_mpi PROPERTY EXPORT_NAME cxx11_mpi)
  set_property(TARGET adios2_cxx11_mpi PROPERTY OUTPUT_NAME adios2${ADIOS2_LIBRARY_SUFFIX}_cxx11_mpi)
  target_link_libraries(adios2_cxx11_mpi PUBLIC adios2_cxx11 PRIVATE adios2_core_mpi PUBLIC MPI::MPI_CXX)
  set(maybe_adios2_cxx11_mpi adios2_cxx11_mpi)
  target_compile_definitions(adios2_cxx11_mpi INTERFACE ADIOS2_USE_MPI)
  add_library(adios2::cxx11_mpi ALIAS adios2_cxx11_mpi)
else()
  set(maybe_adios2_cxx11_mpi)
endif()

# Set library version information
set_target_properties(
  adios2_cxx11 ${maybe_adios2_cxx11_mpi}
  PROPERTIES
  VERSION ${ADIOS2_LIBRARY_VERSION}
  SOVERSION ${ADIOS2_VERSION_MAJOR}
)

install(TARGETS adios2_cxx11 ${maybe_adios2_cxx11_mpi} EXPORT adios2CXX11Exports
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR} COMPONENT adios2_cxx11-runtime
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR} COMPONENT adios2_cxx11-libraries NAMELINK_COMPONENT adios2_cxx11-development
  ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR} COMPONENT adios2_cxx11-development
)

install(
  FILES adios2.h 
  DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
  COMPONENT adios2_cxx11-development
)

install(
  FILES adios2/cxx11/fstream/ADIOS2fstream.h 
  DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/adios2/cxx11/fstream
  COMPONENT adios2_cxx11-development
)

install(
  FILES adios2/cxx11/ADIOS.h 
        adios2/cxx11/ADIOS.inl
        adios2/cxx11/IO.h
        adios2/cxx11/Variable.h 
        adios2/cxx11/Attribute.h
        adios2/cxx11/Engine.h
        adios2/cxx11/Operator.h
        adios2/cxx11/Query.h
        adios2/cxx11/Types.h
  DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/adios2/cxx11
  COMPONENT adios2_cxx11-development
)

export(EXPORT adios2CXX11Exports
  FILE ${ADIOS2_BINARY_DIR}/adios2-cxx11-targets.cmake
  NAMESPACE adios2::
)
install(EXPORT adios2CXX11Exports
  FILE adios2-cxx11-targets.cmake
  NAMESPACE adios2::
  DESTINATION ${CMAKE_INSTALL_CMAKEDIR}
  COMPONENT adios2_cxx11-development
)

=== bindings/Fortran/CMakeLists.txt ===
#------------------------------------------------------------------------------#
# Distributed under the OSI-approved Apache License, Version 2.0.  See
# accompanying file Copyright.txt for details.
#------------------------------------------------------------------------------#

set(CMAKE_Fortran_MODULE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})
include(FortranCInterface)
FortranCInterface_HEADER(FC.h MACRO_NAMESPACE "FC_")
FortranCInterface_VERIFY(CXX QUIET)

# Check whether the compiler supports Fortran submodule constructs we need.
adios2_check_fortran_submodules(ADIOS2_HAVE_FORTRAN_SUBMODULES)

if(ADIOS2_USE_Fortran_flag_argument_mismatch)
  set(CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} -fallow-argument-mismatch")
endif()

add_library(adios2_fortran
  f2c/adios2_f2c_adios.cpp
  f2c/adios2_f2c_attribute.cpp
  f2c/adios2_f2c_io.cpp
  f2c/adios2_f2c_variable.cpp
  f2c/adios2_f2c_engine.cpp
  f2c/adios2_f2c_operator.cpp

  modules/adios2_mod.f90
  modules/adios2_functions_mod.f90
  modules/adios2_functions_allocate_mod.f90
  modules/adios2_parameters_mod.f90
  modules/adios2_adios_mod.f90
  modules/adios2_adios_init_mod.F90
  modules/adios2_adios_init_mod_serial.F90
  modules/adios2_attribute_mod.f90
  modules/adios2_attribute_data_mod.f90
  modules/adios2_io_mod.f90
  modules/adios2_io_open_mod.F90
  modules/adios2_io_open_mod_serial.F90
  modules/adios2_io_define_variable_mod.f90
  modules/adios2_io_define_attribute_mod.f90
  modules/adios2_engine_mod.f90
  modules/adios2_engine_begin_step_mod.f90
  modules/adios2_engine_put_mod.f90
  modules/adios2_engine_get_mod.f90
  modules/adios2_variable_mod.f90
  modules/adios2_variable_min_mod.f90
  modules/adios2_variable_max_mod.f90
  modules/adios2_operator_mod.f90
)
set_property(TARGET adios2_fortran PROPERTY EXPORT_NAME fortran)
set_property(TARGET adios2_fortran PROPERTY OUTPUT_NAME adios2${ADIOS2_LIBRARY_SUFFIX}_fortran)

target_include_directories(adios2_fortran
  PUBLIC
    $<BUILD_INTERFACE:${CMAKE_Fortran_MODULE_DIRECTORY}>
    $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}/adios2/fortran>
  PRIVATE
    ${CMAKE_CURRENT_BINARY_DIR}
)

target_link_libraries(adios2_fortran
  PRIVATE
    adios2_c
    adios2_core
)

if(ADIOS2_HAVE_FORTRAN_SUBMODULES)
  target_compile_definitions(adios2_fortran PRIVATE "$<$<COMPILE_LANGUAGE:Fortran>:ADIOS2_HAVE_FORTRAN_SUBMODULES>")
endif()

# Set library version information
set_target_properties(adios2_fortran PROPERTIES
  VERSION ${ADIOS2_LIBRARY_VERSION}
  SOVERSION ${ADIOS2_VERSION_MAJOR}
)

add_library(adios2::fortran ALIAS adios2_fortran)

if(ADIOS2_HAVE_MPI)
  target_compile_definitions(adios2_fortran PRIVATE "$<$<COMPILE_LANGUAGE:Fortran>:ADIOS2_HAVE_MPI_F>")

  set(adios2_fortran_mpi_srcs
    modules/adios2_adios_init_mod_mpi.F90
    modules/adios2_io_open_mod_mpi.F90
    f2c/adios2_f2c_adios_mpi.cpp
    f2c/adios2_f2c_io_mpi.cpp
    )

  if(ADIOS2_HAVE_FORTRAN_SUBMODULES)
    # With submodules we can put MPI implementations in a separate library.
    add_library(adios2_fortran_mpi ${adios2_fortran_mpi_srcs})
    target_include_directories(adios2_fortran_mpi PRIVATE ${CMAKE_CURRENT_BINARY_DIR})
    target_link_libraries(adios2_fortran_mpi
      PUBLIC
        adios2_fortran
      PRIVATE
        adios2_c_mpi
        adios2_core_mpi
      PUBLIC
        MPI::MPI_Fortran
    )
    target_compile_definitions(adios2_fortran_mpi PRIVATE "$<$<COMPILE_LANGUAGE:Fortran>:ADIOS2_HAVE_FORTRAN_SUBMODULES;ADIOS2_HAVE_MPI_F>")
    set_target_properties(adios2_fortran_mpi PROPERTIES
      VERSION ${ADIOS2_LIBRARY_VERSION}
      SOVERSION ${ADIOS2_VERSION_MAJOR}
    )
    set_property(TARGET adios2_fortran_mpi PROPERTY OUTPUT_NAME adios2${ADIOS2_LIBRARY_SUFFIX}_fortran_mpi)
  else()
    # Without submodules we need to put everything in one library.
    add_library(adios2_fortran_mpi INTERFACE)
    target_link_libraries(adios2_fortran_mpi INTERFACE adios2_fortran MPI::MPI_Fortran)
    target_sources(adios2_fortran PRIVATE ${adios2_fortran_mpi_srcs})
    target_link_libraries(adios2_fortran PRIVATE adios2_c_mpi adios2_core_mpi)
  endif()

  set_property(TARGET adios2_fortran_mpi PROPERTY EXPORT_NAME fortran_mpi)
  target_compile_definitions(adios2_fortran_mpi INTERFACE ADIOS2_USE_MPI)
  add_library(adios2::fortran_mpi ALIAS adios2_fortran_mpi)
  set(maybe_adios2_fortran_mpi adios2_fortran_mpi)
else()
  set(maybe_adios2_fortran_mpi)
endif()

add_library(adios2_f INTERFACE)
target_link_libraries(adios2_f INTERFACE ${maybe_adios2_fortran_mpi} adios2_fortran)

install(
  TARGETS adios2_fortran ${maybe_adios2_fortran_mpi} adios2_f EXPORT adios2FortranExports
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR} COMPONENT adios2_fortran-runtime
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR} COMPONENT adios2_fortran-libraries NAMELINK_COMPONENT adios2_fortran-development
  ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR} COMPONENT adios2_fortran-development
)
install(
  DIRECTORY ${CMAKE_Fortran_MODULE_DIRECTORY}/
  DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/adios2/fortran
  COMPONENT adios2_fortran-development
  FILES_MATCHING
    PATTERN "adios2*.mod"
    PATTERN "CMakeFiles" EXCLUDE
)

export(EXPORT adios2FortranExports
  FILE ${ADIOS2_BINARY_DIR}/adios2-fortran-targets.cmake
  NAMESPACE adios2::
)
install(EXPORT adios2FortranExports
  FILE adios2-fortran-targets.cmake
  NAMESPACE adios2::
  DESTINATION ${CMAKE_INSTALL_CMAKEDIR}
  COMPONENT adios2_fortran-development
)

=== examples/hello/CMakeLists.txt ===
#------------------------------------------------------------------------------#
# Distributed under the OSI-approved Apache License, Version 2.0.  See
# accompanying file Copyright.txt for details.
#------------------------------------------------------------------------------#

add_subdirectory(bpWriter)
add_subdirectory(bpReader)
add_subdirectory(bpTimeWriter)
add_subdirectory(bpFlushWriter)
add_subdirectory(bpAttributeWriter)
add_subdirectory(inlineReaderWriter)
add_subdirectory(skeleton)

if(ADIOS2_HAVE_DataMan)
  add_subdirectory(datamanReader)
  add_subdirectory(datamanWriter)
endif()

if(ADIOS2_HAVE_DataSpaces)
  add_subdirectory(dataspacesReader)
  add_subdirectory(dataspacesWriter)
endif()

if(ADIOS2_HAVE_SST)
  add_subdirectory(sstReader)
  add_subdirectory(sstWriter)
endif()

if(ADIOS2_HAVE_HDF5)
  add_subdirectory(hdf5Writer)
  add_subdirectory(hdf5Reader)
endif()

if(ADIOS2_HAVE_MPI)
  add_subdirectory(insituMPI)
  add_subdirectory(bpFWriteCRead)
endif()

=== testing/adios2/CMakeLists.txt ===
#------------------------------------------------------------------------------#
# Distributed under the OSI-approved Apache License, Version 2.0.  See
# accompanying file Copyright.txt for details.
#------------------------------------------------------------------------------#

add_subdirectory(interface)
add_subdirectory(engine)
add_subdirectory(transports)
add_subdirectory(bindings)
add_subdirectory(xml)
add_subdirectory(yaml)
add_subdirectory(performance)
add_subdirectory(helper)

=== testing/install/CMakeLists.txt ===
#------------------------------------------------------------------------------#
# Distributed under the OSI-approved Apache License, Version 2.0.  See
# accompanying file Copyright.txt for details.
#------------------------------------------------------------------------------#

function(add_install_cmake_test name)
  add_test(NAME Install.CMake.${name} COMMAND "${CMAKE_COMMAND}"
    "-DADIOS2_SOURCE_DIR=${CMAKE_SOURCE_DIR}"
    "-DADIOS2_BINARY_DIR=${CMAKE_BINARY_DIR}"
    "-DCMAKE_GENERATOR=${CMAKE_GENERATOR}"
    "-DCMAKE_GENERATOR_PLATFORM=${CMAKE_GENERATOR_PLATFORM}"
    "-DCMAKE_GENERATOR_TOOLSET=${CMAKE_GENERATOR_TOOLSET}"
    "-DCMAKE_MAKE_PROGRAM=${CMAKE_MAKE_PROGRAM}"
    "-DTEST_CASE=${name}"
    "-DCMAKE_INSTALL_BINDIR=${CMAKE_INSTALL_BINDIR}"
    "-DCMAKE_INSTALL_CMAKEDIR=${CMAKE_INSTALL_CMAKEDIR}"
    "-DCMAKE_C_COMPILER=${CMAKE_C_COMPILER}"
    "-DCMAKE_CXX_COMPILER=${CMAKE_CXX_COMPILER}"
    "-DCMAKE_Fortran_COMPILER=${CMAKE_Fortran_COMPILER}"
    "-DCMAKE_C_FLAGS=${CMAKE_C_FLAGS}"
    "-DCMAKE_CXX_FLAGS=${CMAKE_CXX_FLAGS}"
    "-DCMAKE_Fortran_FLAGS=${CMAKE_Fortran_FLAGS}"
    "-DCMAKE_EXE_LINKER_FLAGS=${CMAKE_EXE_LINKER_FLAGS}"
    "-DBUILD_TYPE=$<CONFIG>"
    "-DMPIEXEC_EXECUTABLE=${MPIEXEC_EXECUTABLE}"
    "-DMPIEXEC_EXTRA_FLAGS=${MPIEXEC_EXTRA_FLAGS}"
    -P "${CMAKE_CURRENT_SOURCE_DIR}/run_cmake.cmake"
    )
  set_tests_properties(Install.CMake.${name} PROPERTIES
    DEPENDS Install.Setup
    FIXTURES_REQUIRED Install
    )
endfunction()

function(add_install_make_test name)
  if(ADIOS2_HAVE_MPI)
    set(cc "${MPI_C_COMPILER}")
    set(cxx "${MPI_CXX_COMPILER}")
    set(fc "${MPI_Fortran_COMPILER}")
    set(mpiexec "${MPIEXEC_EXECUTABLE}")
    set(mpiexec_extra_flags "${MPIEXEC_EXTRA_FLAGS}")
  else()
    set(cc "${CMAKE_C_COMPILER}")
    set(cxx "${CMAKE_CXX_COMPILER}")
    set(fc "${CMAKE_Fortran_COMPILER}")
    set(mpiexec)
    set(mpiexec_extra_flags)
  endif()
  add_test(NAME Install.Make.${name} COMMAND "${CMAKE_COMMAND}"
    "-DADIOS2_SOURCE_DIR=${CMAKE_SOURCE_DIR}"
    "-DADIOS2_BINARY_DIR=${CMAKE_BINARY_DIR}"
    "-DADIOS2_HAVE_MPI=${ADIOS2_HAVE_MPI}"
    "-DADIOS2_EXECUTABLE_SUFFIX=${ADIOS2_EXECUTABLE_SUFFIX}"
    "-DMAKE_COMMAND=${MAKE_COMMAND}"
    "-DCMAKE_C_COMPILER=${cc}"
    "-DCMAKE_CXX_COMPILER=${cxx}"
    "-DCMAKE_Fortran_COMPILER=${fc}"
    "-DCMAKE_C_FLAGS=${CMAKE_C_FLAGS}"
    "-DCMAKE_CXX_FLAGS=${CMAKE_CXX_FLAGS}"
    "-DCMAKE_Fortran_FLAGS=${CMAKE_Fortran_FLAGS}"
    "-DCMAKE_EXE_LINKER_FLAGS=${CMAKE_EXE_LINKER_FLAGS}"
    "-DTEST_CASE=${name}"
    "-DCMAKE_INSTALL_BINDIR=${CMAKE_INSTALL_BINDIR}"
    "-DMPIEXEC_EXECUTABLE=${mpiexec}"
    "-DMPIEXEC_EXTRA_FLAGS=${mpiexec_extra_flags}"
    "-DCMAKE_OSX_SYSROOT=${CMAKE_OSX_SYSROOT}"
    -P "${CMAKE_CURRENT_SOURCE_DIR}/run_make.cmake"
    )
  set_tests_properties(Install.Make.${name} PROPERTIES
    DEPENDS Install.Setup
    FIXTURES_REQUIRED Install
    )
endfunction()

add_test(NAME Install.Setup COMMAND "${CMAKE_COMMAND}"
  "-DADIOS2_SOURCE_DIR=${CMAKE_SOURCE_DIR}"
  "-DADIOS2_BINARY_DIR=${CMAKE_BINARY_DIR}"
  "-DBUILD_TYPE=$<CONFIG>"
  -P "${CMAKE_CURRENT_SOURCE_DIR}/run_install.cmake"
  )
set_tests_properties(Install.Setup PROPERTIES
  FIXTURES_SETUP Install
  )

add_install_cmake_test(C)
add_install_cmake_test(CXX11)
if(ADIOS2_HAVE_Fortran)
  add_install_cmake_test(Fortran)
endif()

if(NOT WIN32)
  find_program(MAKE_COMMAND make)
  if(MAKE_COMMAND)
    add_install_make_test(C)
    add_install_make_test(CXX11)
    if(ADIOS2_HAVE_Fortran)
      add_install_make_test(Fortran)
    endif()
  endif()
endif()

=== testing/adios2/engine/CMakeLists.txt ===
#------------------------------------------------------------------------------#
# Distributed under the OSI-approved Apache License, Version 2.0.  See
# accompanying file Copyright.txt for details.
#------------------------------------------------------------------------------#

add_subdirectory(bp)
add_subdirectory(skeleton)
add_subdirectory(inline)
add_subdirectory(null)
add_subdirectory(nullcore)

if(ADIOS2_HAVE_HDF5)
  add_subdirectory(hdf5)
endif()

if(ADIOS2_HAVE_DataMan)
  add_subdirectory(dataman)
endif()

if(ADIOS2_HAVE_Table)
  add_subdirectory(table)
endif()

if(ADIOS2_HAVE_SSC)
  add_subdirectory(ssc)
endif()

if(ADIOS2_HAVE_SST)
  add_subdirectory(sst)
endif()

if(ADIOS2_HAVE_MPI)
  add_subdirectory(common)
  add_subdirectory(insitumpi)
endif()

add_subdirectory(staging-common)

=== testing/adios2/yaml/CMakeLists.txt ===
#------------------------------------------------------------------------------#
# Distributed under the OSI-approved Apache License, Version 2.0.  See
# accompanying file Copyright.txt for details.
#------------------------------------------------------------------------------#

gtest_add_tests_helper(YAMLConfig MPI_ALLOW "" "" "")
gtest_add_tests_helper(YAMLConfigSerial MPI_NOEXEC "" "" "")

foreach(tgt
    ${Test.YAMLConfig-TARGETS}
    ${Test.YAMLConfigSerial-TARGETS}
    )
  target_compile_definitions(${tgt} PRIVATE
    "YAML_CONFIG_DIR=${CMAKE_CURRENT_SOURCE_DIR}"
    )
endforeach()

=== testing/examples/heatTransfer/CMakeLists.txt ===
#------------------------------------------------------------------------------#
# Distributed under the OSI-approved Apache License, Version 2.0.  See
# accompanying file Copyright.txt for details.
#------------------------------------------------------------------------------#

include(${CMAKE_CURRENT_SOURCE_DIR}/TestBPFileMx1.cmake)
include(${CMAKE_CURRENT_SOURCE_DIR}/TestBPFileMxM.cmake)
include(${CMAKE_CURRENT_SOURCE_DIR}/TestBPFileMxN.cmake)

include(${CMAKE_CURRENT_SOURCE_DIR}/TestInlineMxM.cmake)

if(ADIOS2_HAVE_ZFP)
  #include(${CMAKE_CURRENT_SOURCE_DIR}/TestBPFileMxM_zfp.cmake)
  #include(${CMAKE_CURRENT_SOURCE_DIR}/TestBPFileMxN_zfp.cmake)
  include(${CMAKE_CURRENT_SOURCE_DIR}/TestBPFileMx1_zfp.cmake)
endif()

if(ADIOS2_RUN_MPMD_TESTS)
  if(ADIOS2_HAVE_SST)
    include(${CMAKE_CURRENT_SOURCE_DIR}/TestSSTBPMxM.cmake)
    include(${CMAKE_CURRENT_SOURCE_DIR}/TestSSTBPMxN.cmake)
    include(${CMAKE_CURRENT_SOURCE_DIR}/TestSSTBPMx1.cmake)
    include(${CMAKE_CURRENT_SOURCE_DIR}/TestSSTFFSMxM.cmake)
    include(${CMAKE_CURRENT_SOURCE_DIR}/TestSSTFFSMxN.cmake)
    include(${CMAKE_CURRENT_SOURCE_DIR}/TestSSTFFSMx1.cmake)
    if(ADIOS2_SST_HAVE_LIBFABRIC)
    #  include(${CMAKE_CURRENT_SOURCE_DIR}/TestSSTBPRDMAMxN.cmake)
    #  include(${CMAKE_CURRENT_SOURCE_DIR}/TestSSTFFSRDMAMxN.cmake)
    endif()
  endif()
  
  include(${CMAKE_CURRENT_SOURCE_DIR}/TestInsituMPIMxM.cmake)
  include(${CMAKE_CURRENT_SOURCE_DIR}/TestInsituMPIMxN.cmake)
  include(${CMAKE_CURRENT_SOURCE_DIR}/TestInsituMPIMx1.cmake)
endif()

=== testing/install/C/Makefile ===
#------------------------------------------------------------------------------#
# Distributed under the OSI-approved Apache License, Version 2.0.  See
# accompanying file Copyright.txt for details.
#------------------------------------------------------------------------------#

ifeq ($(ADIOS2_HAVE_MPI),1)
	main_c=main_mpi.c
	mpiexec=$(MPIEXEC)
	test_mpi=test_mpi
else
	main_c=main_nompi.c
	mpiexec=
	test_mpi=
endif

all: test test_serial $(test_mpi)

test: adios_c_test adios_c_test_2
	$(mpiexec) ./adios_c_test
	$(mpiexec) ./adios_c_test_2

adios_c_test: main.o
	$(CXX) $(LDFLAGS) $(CXXFLAGS) -o adios_c_test main.o $(shell adios2-config$(ADIOS2_EXECUTABLE_SUFFIX) --c-libs)

main.o: $(main_c)
	$(CC) $(CFLAGS) $(ISYSROOT) -o main.o -c $(main_c) $(shell adios2-config$(ADIOS2_EXECUTABLE_SUFFIX) --c-flags)

adios_c_test_2: $(main_c)
	$(CXX) $(LDFLAGS) $(CXXFLAGS) $(ISYSROOT) -o adios_c_test_2 $(main_c) $(shell adios2-config$(ADIOS2_EXECUTABLE_SUFFIX) -c)


test_serial: adios_c_serial_test adios_c_serial_test_2
	./adios_c_serial_test
	./adios_c_serial_test_2

adios_c_serial_test: main_nompi.o
	$(CXX) $(LDFLAGS) $(CXXFLAGS) -o adios_c_serial_test main_nompi.o $(shell adios2-config$(ADIOS2_EXECUTABLE_SUFFIX) --serial --c-libs)

main_nompi.o: main_nompi.c
	$(CC) $(CFLAGS) $(ISYSROOT) -o main_nompi.o -c main_nompi.c $(shell adios2-config$(ADIOS2_EXECUTABLE_SUFFIX) -s --c-flags)

adios_c_serial_test_2: main_nompi.o
	$(CXX) $(LDFLAGS) $(CXXFLAGS) $(ISYSROOT) -o adios_c_serial_test_2 main_nompi.c $(shell adios2-config$(ADIOS2_EXECUTABLE_SUFFIX) -s -c)


test_mpi: adios_c_mpi_test adios_c_mpi_test_2
	$(MPIEXEC) ./adios_c_mpi_test
	$(MPIEXEC) ./adios_c_mpi_test_2

adios_c_mpi_test: main_mpi.o
	$(CXX) $(LDFLAGS) $(CXXFLAGS) -o adios_c_mpi_test main_mpi.o $(shell adios2-config$(ADIOS2_EXECUTABLE_SUFFIX) --mpi --c-libs)

main_mpi.o: main_mpi.c
	$(CC) $(CFLAGS) $(ISYSROOT) -o main_mpi.o -c main_mpi.c $(shell adios2-config$(ADIOS2_EXECUTABLE_SUFFIX) -m --c-flags)

adios_c_mpi_test_2: main_mpi.o
	$(CXX) $(LDFLAGS) $(CXXFLAGS) $(ISYSROOT) -o adios_c_mpi_test_2 main_mpi.c $(shell adios2-config$(ADIOS2_EXECUTABLE_SUFFIX) -m -c)

=== debian/changelog ===
adios2 (2.5.0+g2020.05.21+dfsg1-1~) UNRELEASED; urgency=medium

  * Initial release (Closes: #960339)

 -- Kyle Edwards <kyle.edwards@kitware.com>  Wed, 13 May 2020 19:37:53 +0000

=== debian/control ===
Source: adios2
Priority: optional
Maintainer: Kitware Debian Maintainers <debian@kitware.com>
Uploaders:
    Kyle Edwards <kyle.edwards@kitware.com>,
    Kitware Robot <kwrobot@kitware.com>
Build-Depends:
    debhelper-compat (= 12),
    dh-cmake-compat (= 1),
    dh-sequence-cmake,
    dh-sequence-ctest,
    dh-sequence-python3,
    cmake,
    ninja-build,
    g++,
    gfortran,
    pkg-config,
    libevpath-dev,
    libpugixml-dev,
    libyaml-cpp-dev,
    pybind11-dev,
    libgtest-dev,
    nlohmann-json3-dev,
    python3-all,
    libpython3-dev,
    python3-numpy,
    libblosc-dev,
    libbz2-dev,
    libpng-dev,
    libczmq-dev,
    libhdf5-serial-dev,
    libhdf5-openmpi-dev,
    libfabric-dev,
    libffi-dev,
    libopenmpi-dev,
    python3-mpi4py
Standards-Version: 4.5.0
Section: libs
Homepage: https://github.com/ornladios/ADIOS2
Vcs-Browser: https://gitlab.kitware.com/debian/adios2
Vcs-Git: https://gitlab.kitware.com/debian/adios2.git

Package: adios2-data
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: ADIOS2 Adaptable IO system for simulations - tool data
 The Adaptable IO System (ADIOS) provides a simple, flexible way for
 scientists to describe the data in their code that may need to be
 written, read, or processed outside of the running simulation. By
 providing an external to the code XML file describing the various
 elements, their types, and how you wish to process them this run, the
 routines in the host code (either Fortran or C) can transparently
 change how they process the data.
 .
 This package contains tool data for ADIOS2.

Package: adios2-scripts
Architecture: all
Multi-Arch: foreign
Depends: ${python3:Depends}, ${misc:Depends}
Description: ADIOS2 Adaptable IO system for simulations - scripts
 The Adaptable IO System (ADIOS) provides a simple, flexible way for
 scientists to describe the data in their code that may need to be
 written, read, or processed outside of the running simulation. By
 providing an external to the code XML file describing the various
 elements, their types, and how you wish to process them this run, the
 routines in the host code (either Fortran or C) can transparently
 change how they process the data.
 .
 This package contains scripts for ADIOS2.

Package: adios2-serial-bin
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: ADIOS2 Adaptable IO system for simulations - binary tools (serial)
 The Adaptable IO System (ADIOS) provides a simple, flexible way for
 scientists to describe the data in their code that may need to be
 written, read, or processed outside of the running simulation. By
 providing an external to the code XML file describing the various
 elements, their types, and how you wish to process them this run, the
 routines in the host code (either Fortran or C) can transparently
 change how they process the data.
 .
 This package contains binary tools for ADIOS2.

Package: libadios2-serial-core
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: ADIOS2 Adaptable IO system for simulations - core libraries (serial)
 The Adaptable IO System (ADIOS) provides a simple, flexible way for
 scientists to describe the data in their code that may need to be
 written, read, or processed outside of the running simulation. By
 providing an external to the code XML file describing the various
 elements, their types, and how you wish to process them this run, the
 routines in the host code (either Fortran or C) can transparently
 change how they process the data.
 .
 This package contains the core libraries for the serial build of
 ADIOS2.

Package: libadios2-serial-core-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libadios2-serial-core (= ${binary:Version}), ${misc:Depends}
Description: ADIOS2 Adaptable IO system for simulations - core development files (serial)
 The Adaptable IO System (ADIOS) provides a simple, flexible way for
 scientists to describe the data in their code that may need to be
 written, read, or processed outside of the running simulation. By
 providing an external to the code XML file describing the various
 elements, their types, and how you wish to process them this run, the
 routines in the host code (either Fortran or C) can transparently
 change how they process the data.
 .
 This package contains the core development files for the serial build
 of ADIOS2.

Package: libadios2-serial-c
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: ADIOS2 Adaptable IO system for simulations - C binding libraries (serial)
 The Adaptable IO System (ADIOS) provides a simple, flexible way for
 scientists to describe the data in their code that may need to be
 written, read, or processed outside of the running simulation. By
 providing an external to the code XML file describing the various
 elements, their types, and how you wish to process them this run, the
 routines in the host code (either Fortran or C) can transparently
 change how they process the data.
 .
 This package contains the C binding libraries for the serial build of
 ADIOS2.

Package: libadios2-serial-c-dev
Architecture: any
Multi-Arch: same
Depends:
    libadios2-serial-c (= ${binary:Version}),
    libadios2-serial-core-dev (= ${binary:Version}),
    ${misc:Depends}
Description: ADIOS2 Adaptable IO system for simulations - C binding development files (serial)
 The Adaptable IO System (ADIOS) provides a simple, flexible way for
 scientists to describe the data in their code that may need to be
 written, read, or processed outside of the running simulation. By
 providing an external to the code XML file describing the various
 elements, their types, and how you wish to process them this run, the
 routines in the host code (either Fortran or C) can transparently
 change how they process the data.
 .
 This package contains the C binding development files for the serial
 build of ADIOS2.

Package: libadios2-serial-c++11
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: ADIOS2 Adaptable IO system for simulations - C++11 binding libraries (serial)
 The Adaptable IO System (ADIOS) provides a simple, flexible way for
 scientists to describe the data in their code that may need to be
 written, read, or processed outside of the running simulation. By
 providing an external to the code XML file describing the various
 elements, their types, and how you wish to process them this run, the
 routines in the host code (either Fortran or C) can transparently
 change how they process the data.
 .
 This package contains the C++11 binding libraries for the serial build of
 ADIOS2.

Package: libadios2-serial-c++11-dev
Architecture: any
Multi-Arch: same
Depends:
    libadios2-serial-c++11 (= ${binary:Version}),
    libadios2-serial-core-dev (= ${binary:Version}),
    ${misc:Depends}
Description: ADIOS2 Adaptable IO system for simulations - C++11 binding development files (serial)
 The Adaptable IO System (ADIOS) provides a simple, flexible way for
 scientists to describe the data in their code that may need to be
 written, read, or processed outside of the running simulation. By
 providing an external to the code XML file describing the various
 elements, their types, and how you wish to process them this run, the
 routines in the host code (either Fortran or C) can transparently
 change how they process the data.
 .
 This package contains the C++11 binding development files for the serial
 build of ADIOS2.

Package: libadios2-serial-fortran
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: ADIOS2 Adaptable IO system for simulations - Fortran binding libraries (serial)
 The Adaptable IO System (ADIOS) provides a simple, flexible way for
 scientists to describe the data in their code that may need to be
 written, read, or processed outside of the running simulation. By
 providing an external to the code XML file describing the various
 elements, their types, and how you wish to process them this run, the
 routines in the host code (either Fortran or C) can transparently
 change how they process the data.
 .
 This package contains the Fortran binding libraries for the serial build of
 ADIOS2.

Package: libadios2-serial-fortran-dev
Architecture: any
Multi-Arch: same
Depends:
    libadios2-serial-fortran (= ${binary:Version}),
    libadios2-serial-core-dev (= ${binary:Version}),
    ${misc:Depends}
Description: ADIOS2 Adaptable IO system for simulations - Fortran binding development files (serial)
 The Adaptable IO System (ADIOS) provides a simple, flexible way for
 scientists to describe the data in their code that may need to be
 written, read, or processed outside of the running simulation. By
 providing an external to the code XML file describing the various
 elements, their types, and how you wish to process them this run, the
 routines in the host code (either Fortran or C) can transparently
 change how they process the data.
 .
 This package contains the Fortran binding development files for the serial
 build of ADIOS2.

Package: python3-adios2-serial
Architecture: any
Multi-Arch: same
Depends: ${python3:Depends}, ${shlibs:Depends}, ${misc:Depends}
Provides: ${python3:Provides}
Description: ADIOS2 Adaptable IO system for simulations - Python bindings (serial)
 The Adaptable IO System (ADIOS) provides a simple, flexible way for
 scientists to describe the data in their code that may need to be
 written, read, or processed outside of the running simulation. By
 providing an external to the code XML file describing the various
 elements, their types, and how you wish to process them this run, the
 routines in the host code (either Fortran or C) can transparently
 change how they process the data.
 .
 This package contains the Python bindings for the serial build of
 ADIOS2.

Package: adios2-openmpi-bin
Architecture: any
Depends:
    adios2-data (= ${binary:Version}),
    ${shlibs:Depends},
    ${misc:Depends}
Description: ADIOS2 Adaptable IO system for simulations - binary tools (OpenMPI)
 The Adaptable IO System (ADIOS) provides a simple, flexible way for
 scientists to describe the data in their code that may need to be
 written, read, or processed outside of the running simulation. By
 providing an external to the code XML file describing the various
 elements, their types, and how you wish to process them this run, the
 routines in the host code (either Fortran or C) can transparently
 change how they process the data.
 .
 This package contains binary tools for the OpenMPI build of ADIOS2.

Package: libadios2-openmpi-core
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: ADIOS2 Adaptable IO system for simulations - core libraries (OpenMPI)
 The Adaptable IO System (ADIOS) provides a simple, flexible way for
 scientists to describe the data in their code that may need to be
 written, read, or processed outside of the running simulation. By
 providing an external to the code XML file describing the various
 elements, their types, and how you wish to process them this run, the
 routines in the host code (either Fortran or C) can transparently
 change how they process the data.
 .
 This package contains the core libraries for the OpenMPI build of
 ADIOS2.

Package: libadios2-openmpi-core-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libadios2-openmpi-core (= ${binary:Version}), ${misc:Depends}
Description: ADIOS2 Adaptable IO system for simulations - core development files (OpenMPI)
 The Adaptable IO System (ADIOS) provides a simple, flexible way for
 scientists to describe the data in their code that may need to be
 written, read, or processed outside of the running simulation. By
 providing an external to the code XML file describing the various
 elements, their types, and how you wish to process them this run, the

=== debian/rules ===
#!/usr/bin/make -f

get-orig-source:
	wget -O ../adios2_$(DEBIAN_VERSION).orig.tar.gz --no-clobber https://github.com/ornladios/ADIOS2/archive/$(GIT_VERSION).tar.gz
	mkdir tmp
	tar -C tmp --strip-components=1 -xf ../adios2_$(DEBIAN_VERSION).orig.tar.gz
	cd tmp && rm -r \
	  thirdparty/atl \
	  thirdparty/dill \
	  thirdparty/enet \
	  thirdparty/EVPath \
	  thirdparty/ffs \
	  thirdparty/GTest \
	  thirdparty/mingw-w64 \
	  thirdparty/nlohmann_json \
	  thirdparty/pugixml \
	  thirdparty/pybind11 \
	  thirdparty/yaml-cpp
	tar --owner=root --group=root --transform="s/^tmp/adios2_$(DEBIAN_VERSION)+dfsg1/" -cJf ../adios2_$(DEBIAN_VERSION)+dfsg1.orig.tar.xz tmp
	rm -r tmp

flavors := serial openmpi

%:
	dh $@ --buildsystem=cmake+ninja

configure_flags_common := \
  -DADIOS2_USE_EXTERNAL_DEPENDENCIES:BOOL=ON \
  -DADIOS2_USE_EXTERNAL_EVPATH:BOOL=ON \
  -DADIOS2_USE_BZip2:BOOL=ON \
  -DADIOS2_USE_Blosc:BOOL=ON \
  -DADIOS2_USE_Fortran:BOOL=ON \
  -DADIOS2_USE_HDF5:BOOL=ON \
  -DADIOS2_USE_PNG:BOOL=ON \
  -DADIOS2_USE_SST:BOOL=ON \
  -DADIOS2_USE_ZeroMQ:BOOL=ON

configure_flags_serial := $(configure_flags_common) \
  -DCMAKE_INSTALL_CMAKEDIR:STRING=lib/$(DEB_HOST_GNU_TYPE)/cmake/adios2/serial \
  -DADIOS2_LIBRARY_SUFFIX:STRING=_serial \
  -DADIOS2_EXECUTABLE_SUFFIX:STRING=.serial \
  -DADIOS2_USE_Python:BOOL=ON \
  -DADIOS2_USE_MPI:BOOL=OFF \
  -DHDF5_C_COMPILER_EXECUTABLE:FILEPATH=/usr/bin/h5cc

configure_flags_openmpi := $(configure_flags_common) \
  -DCMAKE_INSTALL_CMAKEDIR:STRING=lib/$(DEB_HOST_GNU_TYPE)/cmake/adios2/openmpi \
  -DADIOS2_LIBRARY_SUFFIX:STRING=_openmpi \
  -DADIOS2_EXECUTABLE_SUFFIX:STRING=.openmpi \
  -DADIOS2_USE_Python:BOOL=ON \
  -DADIOS2_USE_MPI:BOOL=ON \
  -DADIOS2_USE_SSC:BOOL=ON \
  -DMPI_C_COMPILER:FILEPATH=/usr/bin/mpicc.openmpi \
  -DMPI_CXX_COMPILER:FILEPATH=/usr/bin/mpic++.openmpi \
  -DMPI_Fortran_COMPILER:FILEPATH=/usr/bin/mpif77.openmpi \
  -DHDF5_C_COMPILER_EXECUTABLE:FILEPATH=/usr/bin/h5pcc.openmpi

override_dh_auto_clean:
	dh_clean $(foreach flavor,$(flavors),build-$(flavor)/ install-$(flavor)/)

start_%: flavor = $(patsubst start_%,%,$@)
start_%:
	dh_ctest_start --ctest-testing-dir=build-$(flavor) --builddirectory=build-$(flavor) --ctest-build-suffix=-$(flavor)

override_dh_ctest_start: $(foreach flavor,$(flavors),start_$(flavor))

update_%: flavor = $(patsubst update_%,%,$@)
update_%:
	dh_ctest_update --ctest-testing-dir=build-$(flavor) --builddirectory=build-$(flavor) --ctest-build-suffix=-$(flavor)

override_dh_ctest_update: $(foreach flavor,$(flavors),update_$(flavor))

configure_%: flavor = $(patsubst configure_%,%,$@)
configure_%:
	dh_ctest_configure -O--ctest-testing-dir=build-$(flavor) --builddirectory=build-$(flavor) -O--ctest-build-suffix=-$(flavor) -O--buildsystem=cmake+ninja -- $(configure_flags_$(flavor))

override_dh_ctest_configure: $(foreach flavor,$(flavors),configure_$(flavor))

build_%: flavor = $(patsubst build_%,%,$@)
build_%:
	dh_ctest_build -O--ctest-testing-dir=build-$(flavor) --builddirectory=build-$(flavor) -O--ctest-build-suffix=-$(flavor) -O--buildsystem=cmake+ninja

override_dh_ctest_build: $(foreach flavor,$(flavors),build_$(flavor))

test_%: flavor = $(patsubst test_%,%,$@)
test_%:
	dh_ctest_test --ctest-testing-dir=build-$(flavor) --builddirectory=build-$(flavor) --ctest-build-suffix=-$(flavor) -- -R '^Install\.'

override_dh_ctest_test: $(foreach flavor,$(flavors),test_$(flavor))

submit_%: flavor = $(patsubst submit_%,%,$@)
submit_%:
	dh_ctest_submit --ctest-testing-dir=build-$(flavor) --builddirectory=build-$(flavor) --ctest-build-suffix=-$(flavor)

override_dh_ctest_submit: $(foreach flavor,$(flavors),submit_$(flavor))

install_%: flavor = $(patsubst install_%,%,$@)
install_%:
	dh_auto_install --buildsystem=cmake+ninja --builddirectory=build-$(flavor) --destdir=install-$(flavor)
	dh_install --sourcedir=install-$(flavor) --package libadios2-$(flavor)-core-dev usr/bin/adios2-config.$(flavor)

override_dh_auto_install: $(foreach flavor,$(flavors),install_$(flavor))

cmake_install_%: flavor = $(patsubst cmake_install_%,%,$@)
cmake_install_%: cmdbase = dh_cmake_install --builddirectory=build-$(flavor) --sourcedir=install-$(flavor)
cmake_install_%:
	$(cmdbase) --package adios2-$(flavor)-bin            --component adios2_tools-runtime
	$(cmdbase) --package libadios2-$(flavor)-core        --component adios2_core-libraries
	$(cmdbase) --package libadios2-$(flavor)-core-dev    --component adios2_core-development
	$(cmdbase) --package libadios2-$(flavor)-c           --component adios2_c-libraries
	$(cmdbase) --package libadios2-$(flavor)-c-dev       --component adios2_c-development
	$(cmdbase) --package libadios2-$(flavor)-c++11       --component adios2_cxx11-libraries
	$(cmdbase) --package libadios2-$(flavor)-c++11-dev   --component adios2_cxx11-development
	$(cmdbase) --package libadios2-$(flavor)-fortran     --component adios2_fortran-libraries
	$(cmdbase) --package libadios2-$(flavor)-fortran-dev --component adios2_fortran-development

cmake_install_serial_extra: cmdbase = dh_cmake_install --builddirectory=build-serial --sourcedir=install-serial
cmake_install_serial_extra:
	$(cmdbase) --package python3-adios2-serial           --component adios2_python-python

cmake_install_openmpi_extra: cmdbase = dh_cmake_install --builddirectory=build-openmpi --sourcedir=install-openmpi
cmake_install_openmpi_extra:
	$(cmdbase) --package python3-adios2-openmpi          --component adios2_python-python
	$(cmdbase) --package adios2-data                     --component adios2_tools-data

override_dh_cmake_install: cmdbase = dh_cmake_install --builddirectory=build-serial --sourcedir=install-serial
override_dh_cmake_install: $(foreach flavor,$(flavors),cmake_install_$(flavor) cmake_install_$(flavor)_extra)
	$(cmdbase) --package adios2-scripts                  --component adios2_scripts-runtime
	dh_install --sourcedir=debian/adios2 --package python3-adios2-serial \
	  __init__.py usr/lib/python3/dist-packages/adios2
	dh_install --sourcedir=debian/adios2 --package libadios2-serial-core-dev \
	  adios2-config.cmake usr/lib/$(DEB_HOST_GNU_TYPE)/cmake/adios2
	dh_install --sourcedir=install-serial --package libadios2-serial-core-dev \
	  usr/lib/$(DEB_HOST_GNU_TYPE)/cmake/adios2/serial/adios2-config-version.cmake usr/lib/$(DEB_HOST_GNU_TYPE)/cmake/adios2

missing_%: flavor = $(patsubst missing_%,%,$@)
missing_%:
	dh_missing --sourcedir=install-$(flavor)

override_dh_missing: $(foreach flavor,$(flavors),missing_$(flavor))
